﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.HeatingHelper.UI.UIModule
{
    /// <summary>
    /// HeatThickDetector.xaml 的交互逻辑
    /// </summary>
    public partial class HeatThickDetector : Page
    {
        //ThickHeatData4SQLite_V1 _thickHeatData4SQLite_V1;
        IThickHeatData _dat;
        public HeatThickDetector()
        {
            InitializeComponent();
            _dat = DataManager.GetThickDataInstance();
            _dat.SetDB(@"D:\blowingdata\airring.sqlite3");
            this.DataContext = _dat;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (!_dat.IsDataReady) return;
                NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                if(_dat.BeginUse())
                {
                    Page_HeatDetector page = new Page_HeatDetector();
                    page.InitData(_dat);
                    ns.Navigate(page);
                }
            }
        }
    }
    public class UIModule_HeatThickDetector : FLY.UI.Module.IUIModule
    {
        #region IUIModule实现
        public string Title => "风环辅助";

        public FrameworkElement GetComponent(int id)
        {
            HeatThickDetector fe = new HeatThickDetector();
            return fe;
        }

        public FrameworkElement GetThumbnail(int id)
        {
            return new System.Windows.Controls.Grid();
        }

        public void MatchParam(int[] IDs)
        {
        }
        #endregion
    }

    public class StateToMessage : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            StateCode s = (StateCode)value;
            switch (s)
            {
                case StateCode.STC_IDLE:
                    return "等待新数据";
                case StateCode.STC_NODAT:
                    return "没有数据";
                case StateCode.STC_READING:
                    return "正在读取数据...";
                case StateCode.STC_UPDATING:
                    return "正在检查新数据...";
            }
            return "未知状态";
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
