﻿using MahApps.Metro.Controls;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;

namespace DB.Browser
{
    /// <summary>
    /// App.xaml 的交互逻辑
    /// </summary>
    public partial class App : Application
    {
        NLog.Logger log = NLog.LogManager.GetLogger("app");

        public static MetroWindow MetroWindow { get; set; }
        public App()
        {
            AppDomain.CurrentDomain.UnhandledException += (s, e) =>
            {
                string err = e.ExceptionObject.ToString();

                log.Error(err);

                MessageBox.Show("程序出现异常，请把下面信息拍照发给厂家" + Environment.NewLine + err,
                    "异常，联系厂家",
                    MessageBoxButton.OK, MessageBoxImage.Error);

            };

            //AutoMapper 初始化
            //所有使用到 AutoMapper 的程序集 必须主动显式 在这里加载。
            //当为 dll 反射加载的 程序集， 应该在此提前 加载。
            var cfg = new AutoMapper.Configuration.MapperConfigurationExpression();
            var assemblies = System.AppDomain.CurrentDomain.GetAssemblies();
            cfg.AddMaps(assemblies);
            //cfg.AddMaps("FLY.Thick.Normal");
            AutoMapper.Mapper.Initialize(cfg);
        }
    }
}
